/*
 *  AnalogReadFast.h
 * 
 *  Copyright (C) 2016  Albert van Dalen http://www.avdweb.nl
 * 
 *  This file is part of CommandStation.
 *
 *  CommandStation is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CommandStation is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with CommandStation.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef COMMANDSTATION_DCC_ANALOGREADFAST_H_
#define COMMANDSTATION_DCC_ANALOGREADFAST_H_

#include <Arduino.h>

int inline analogReadFast(uint8_t ADCpin);
#if defined(ARDUINO_ARCH_MEGAAVR)

int inline analogReadFast(uint8_t ADCpin) 
{ byte ADC0CTRLCoriginal = ADC0.CTRLC; 
  ADC0.CTRLC = (ADC0CTRLCoriginal & 0b00110000) + 0b01000011; 
  int adc = analogRead(ADCpin);  
  ADC0.CTRLC = ADC0CTRLCoriginal;
  return adc;
}
#else 
int inline analogReadFast(uint8_t ADCpin) 
{ byte ADCSRAoriginal = ADCSRA; 
  ADCSRA = (ADCSRA & B11111000) | 4; 
  int adc = analogRead(ADCpin);  
  ADCSRA = ADCSRAoriginal;
  return adc;
}
#endif
#endif  // COMMANDSTATION_DCC_ANALOGREADFAST_H_
